
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>项目经理叫你改 Bug，后来就发生了…… / iVAN</title>

    <meta name="description" content="项目经理叫你改 Bug，后来就发生了…… 你曾经碰到过现在这种情况: 你的代码非常优雅. 你代码中的抽象刚刚好,不多不少. 你的模块都各自独立. 所有的测试结果都是绿色的.代码测试覆盖率报告花了整整一分钟才打开,上面显示着 97%-- 生活很美好. 然后事情就这么发生了. 一个 PM(产品经理)跑进来,跟你说上周你发布的那个更新里面有个 bug.不论什么时候,只要用户在购物车里添加了一件商品,购物车中的计数过个好几秒才会更新.本来应该立即更新的. PM 跟你说用户的抱怨如潮水般用来,他问你:你能看一眼么? 当然你能看一眼,毕竟这是你做的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">项目经理叫你改 Bug，后来就发生了……</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>你曾经碰到过现在这种情况：</p>
<p>你的代码非常优雅。</p>
<p>你代码中的抽象刚刚好，不多不少。</p>
<p>你的模块都各自独立。</p>
<p>所有的测试结果都是绿色的。代码测试覆盖率报告花了整整一分钟才打开，上面显示着 97%……</p>
<p>生活很美好。</p>
<p>然后事情就这么发生了。</p>
<p>一个 PM（产品经理）跑进来，跟你说上周你发布的那个更新里面有个 bug。不论什么时候，只要用户在购物车里添加了一件商品，购物车中的计数过个好几秒才会更新。本来应该立即更新的。</p>
<p>PM 跟你说用户的抱怨如潮水般用来，他问你：你能看一眼么？</p>
<p>当然你能看一眼，毕竟这是你做的东西。很可能是其他什么人犯了错。不过你会修复这个问题的。你就是这么正直的员工。</p>
<p>你在 Git 上把最新的发布版本同步下来，然后开始研究变更日志。在上一个发布版本中，你把 HTTP request 库更新到了最新版。那次审核过了好长的时间。你还能记得这次修改确切的提交所在，那天的天气不错。</p>
<p>你切换到那次提交，然后模拟了一下更新购物车的请求。不错 ，你已经充分考虑到了代码的独立性，可以很容易地在测试环境和生产环境中进行测试，只需要切换一个构建标记就够了。</p>
<p>你找到了那个罪魁祸首。看起来你更新的那个 HTTP 库有个回归（regression）。对于特定类型的请求，它花了太长的时间来解析传入的 JSON 负载。你的应用只能在请求负载解析完成之后才能更新那个计数器。在架构上还没有处理最终一致性的问题，要加上这种设计的话，本身就足够当成一个项目来做了。所以你没法在本地先更新计数器随后再同步到服务器上。</p>
<p>你知道这是别人犯的错。唉，这就是生活。</p>
<p>你把事情的原因告诉了 PM。他拍了拍你的背，知道这不怪你。你能把这个问题修复么？</p>
<p>当然。</p>
<p>你已经考虑好你的解决办法。</p>
<p>你不能把变更都回滚。有一大堆新的代码和 bug 的修复都依赖于这个新版的库，要是你把所有东西都回滚的话，这些就都白干了。</p>
<p>只是把这个库 fork 下来然后维护一个你自己的版本看上去也不太可行。之前这个项目的维护者有一个超级完备的测试架构，会在上千台设备上测试你修复的代码。而你只有三台设备，其中两个的操作系统版本都老掉牙了。最好还是需要他们的反馈，毕竟这是他们维护的库，他们对其内部结构很了解，而你不了解。</p>
<p>所以你打算这么干：</p>
<p>Fork 这个库</p>
<p>实现代码修复</p>
<p>向原始的 repo 中发一个 pull request</p>
<p>你和维护者可能需要来回几次沟通</p>
<p>最终说服他们相信你的方法才是最好的</p>
<p>代码合并</p>
<p>等着这个库发布一个新的补丁</p>
<p>在你的代码中更新这个库</p>
<p>发布产品的新版本</p>
<p>很简单嘛。</p>
<p>“好极了，”PM 说，“你觉得需要花多长时间？”</p>
<p>你知道这个答案。人们都说程序员不会估算时间，你可不是那种程序员。（《为什么软件开发周期通常是预期的两三倍？》）</p>
<p>“两周，”你眼都不眨地说，“取决于这个 PR 多久才会被接受，还有维护的人多快能发布一个新版本。”</p>
<p>PM 的脸色立刻就变绿了。“两周？两周？！”他重复着同样的话，好像这样能改变一样。不过他还是保持了冷静。PM 知道怎么处理负面的情绪，没什么可担心的。</p>
<p>“我们的用户正在流失！他们什么都不会买了，因为他们没法看到自己购物车里面的更新！我们是个电商公司！这是不可接受的！”</p>
<p>你看着他经历着悲伤的五个阶段（译注：否认、愤怒、讨价还价、绝望、接受）。你等着最后接受的那个过程什么时候会发生。不过并没有。他看起来停在了讨价还价的阶段。</p>
<p>“好吧，”你说着，深陷在你的转椅里，“让我想想。”</p>
<p>你会迁就他一下下，然后他可能就会离开了。你还有很多其他事情要做，你知道的。</p>
<p>你开始翻看源代码。这是你的特长，你的手指敲击着 IDE 的快捷键，就好像海神波塞冬驾驭着大海的波涛。</p>
<p>啊哈！你找到它了！有个文档中没提到的方法，可以在 JSON 解析的代码中插入一个钩子，然后用你自己的实现来替换它！</p>
<p>不过等等。这看起来太丑陋了。这可是个非公开的 API，说不定把它暴露出来是个意外呢。你可不想依赖这种东西，万一他们在下一个版本里把它移除掉了怎么办？那样你就得把这套东西整个都重写一遍了。谁想这么干啊？不过这确实比自己维护一个没测试过的分支要快一些。不过还是太丑陋了。</p>
<p>不要。</p>
<p>你可不想因为商务决策而误导你，毁了你纯净的神殿。你是神圣的守护者，对抗着那些愚昧的事物。这就是为什么他们会付你那么多钱的原因。你的责任就是拒绝这种要求。</p>
<p>你冲进 PM 的屋子。“答案是不要。没有什么优雅的方法来解决它，我不相信丑陋的旁门左道。抱歉。”</p>
<p>他的反应和你预料中的一样。</p>
<p>“你告诉我有个方法可以做到，不过你不想这么做就因为它不够优雅？我们的用户正冲我们叫嚣着，威胁我们要改用我们竞争对手地产品，而你就不愿意修复这个问题，就因为它不够优雅？“</p>
<p>你失败了。</p>
<p>这人懂什么软件工程？你只用代码就凭空创建了这个奇妙的世界。高度可扩展的系统，可以抵抗住来自前苏联集团中所有黑客发向你的 DDoS 攻击。你是个艺术家，而芯片就是你的画布。你已经无数次地阅读了《代码整洁之道》，你对它的了解甚至超过了你对自己 GitHub 密码的印象。</p>
<p>“没错！”你喊道，“我不会用这种垃圾来玷污我们的代码库！我花了好几个月才构建出这些东西！产品里的每一行代码都是我的心血！它们能够正常运行的唯一原因不是你，和你没关系！是像我这样的人们维持着软件的运行，是像我这样的人们，不得不在你和你的那些‘商业功能’完成之后去清理那些乱七八糟的东西！”</p>
<p>你冲出了那儿。你需要喝点什么。这样的人简直就是业界的祸根。他们觉得自己那些花哨的 MBA 证书能让他们知道该如何创造出伟大的软件，而我们这些开发者却不知为什么忽略了这种方法。</p>
<p>你昂首阔步地走进休息区，那是你每天享用那些美食家们推荐的午餐的地方。还有咖啡，不限量的、美味的、滋润着你的灵魂的咖啡。你值得这种享受，因为你是个知识工作者。</p>
<p>你冲了一杯 java 咖啡，想找个地方坐下。</p>
<p>然后你看到了他。</p>
<p>你的公司中最资深的程序员。</p>
<p>这家伙是个彻头彻尾的核心人员，是那种“我在上厕所的工夫就能写出一个编译器”的程序员。在黑客出现之前他就已经是名黑客了。你想要成为这样的人。他就像是指环王里面的甘道夫。这里所有人在所有时候都尊敬和畏惧着他。不过他很和蔼，总是会帮助那些孩子们。他应该愿意听听你和 PM 之间发生的事情。毕竟，他是你这一伙的。</p>
<p>于是你坐到他旁边。他正享受着咖啡，正在看着什么 Haskell 中抽象的数据类型之类的东西。</p>
<p>没错，就得和这样的人聊聊。</p>
<p>你把自己的壮举告诉了他。他耐心地听着，偶尔点点头，问了些问题。他的肢体语言是向后靠着。从他的眼神中你能看得出来，他以前也经历过这种事儿。</p>
<p>你终于说完了。</p>
<p>好累。</p>
<p>你感觉肩上的分量轻了一些。</p>
<p>他看上去陷入了沉思，好像正在谨慎地选择着词汇。</p>
<p>你等着他会大笑着宣布“干的好，孩子！”，然后你们会一起再冲杯咖啡。他会给你讲一个他所经历过的类似的故事，在那一天，他如何斥责一个愚蠢的 PM。</p>
<p>你曾经梦想过这一天。你们会用咖啡碰杯，就像那些在战场上取胜的战士那样。至少，在电影里他们是那么干的。当然，他们通常用的是啤酒，而不是咖啡。</p>
<p>在感情上，你是这么希望的。</p>
<p>你等待着……</p>
<p>继续等待着……</p>
<p>他直直地看向你的双眼，穿透了你的灵魂。那些和电脑一起奋斗过的岁月让他的目光变得如此难以忍受，不过他使用了什么魔法，让你无法移开你的眼睛。</p>
<p>他只说了一件事。</p>
<p>“我们的工作并不是喝喝咖啡敲敲代码。我们的工作是编写能够正常运行的软件。”</p>
<p>然后他就走开了。</p>
<p>你呆住了一分钟。在你肚子里有种什么感觉，一种空荡荡的、恶心的感觉。你开始意识到这种感觉，叫做羞愧。</p>
<p>你让那些你最亏欠的人失望了，那就是你的用户。</p>
<p>于是你回到自己的座位上，迅速搞定了那个“旁门左道”，然后发布了一个新的版本。</p>
<p>你向 PM 道了歉，自己有点失控了。他说没事。最后只要没事就好。</p>
<p>你还是 fork 了这个库，实现了一个正确的修复方式，然后提交了一个 PR。当这个库以正确的解决方法发布新版本的时候，你总是可以重构自己的代码的。<br />
文章转载自 开源中国社区 [<a href="http://www.oschina.net" rel="external nofollow noreferrer">http://www.oschina.net</a>]</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 12:49:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f%e5%91%98/" title="程序员">程序员</a>, <a href="https://www.iamivan.net/tag/%e7%94%b5%e5%95%86/" title="电商">电商</a>, <a href="https://www.iamivan.net/tag/bug/" title="bug">bug</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>项目经理叫你改 Bug，后来就发生了……的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOaOa3M.html" rel="bookmark">史海峰：项目经理的光辉岁月</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目经理,大概是IT行业这么多年以来,流行过的各种火热名头里最早的一个了,从传统IT软件时代就有了.俺大胆猜想,这个词儿是从建筑工程乃至其他工程领域里借鉴过来的.总之项目管理理论和实践历史悠久且相当成熟,从修建金字塔到登陆月球,即便跟IT无关,依然是人类社会协作智慧的传承,具体的历史由来不敢妄言,毕竟本人没学过PMP(俗称拍马屁,接近职场,否则跟PHP一起就都是拍*片了--IT老兵听到PM,第一反应都是项目经理,而非产品经理,如今很多互联网公司也有PMO--Project Management			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwDkEp.html" rel="bookmark">从程序员到项目经理：完美主义也是一种错</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				追求完美是一种可贵的精神,完美主义也历来被认为是一种优秀的品格.可是在项目中,完美主义也是一种错,虽然是一种&quot;美丽的错误&quot;.项目讲求平衡,要的是合格,而不是优秀:要的是70分,而不是100分! 1.两极分化的程序员 相信在很多人眼里,程序员都是工作一丝不苟.对代码精雕细琢.精益求精的人.瞧,他们在电脑前面一坐就是大半天,如果不是追求完美之人,谁能这样坐得住板凳? 可 是依我所见,在&quot;追求完美&quot;这个问题上,程序员其实是严重的两极分化.有一部分程序员确实对自己的代码要求			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p56NgWz.html" rel="bookmark">艾伟也谈项目管理，项目经理成长日记（7）&mdash;&mdash;说是细，做的粗</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				估计绝大部分的公司都在提倡一个口号:&quot;注重细节.&quot;但是往往是口号容易喊,行动却是千辛万苦,何谓细节?也就是自身工作的每一个环节.每一道流程的琐碎小事,而这些小事又常常容易被人忽略.有很多人有雄才大志,内心中充斥着舍我其谁的非凡气魄,但其眼高手低,小事不屑,大事难成,最终只落得一事无成的悲哀. 软件开发亦是如此,提倡了许久的注重细节,更有甚者许多公司标榜自己的优势在于:&quot;我们更注重细节.&quot;然而如果说我们要做到和自己提出的口号一致的时候,我们该如何去做?该做什么的事情才			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlB3kYz.html" rel="bookmark">《嵌入式系统开发之道&mdash;&mdash;菜鸟成长日志与项目经理的私房菜》&mdash;&mdash;02-03项目生命周期五大阶段</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				02-03项目生命周期五大阶段 嵌入式系统开发之道--菜鸟成长日志与项目经理的私房菜 我们前面讲过项目的定义,特别谈到每件项目都是独一无二的,都有各自的目标.可应用的资源.必须面对的限制与风险等.但所谓的知识体系就是要设法异中求同,通过分析与比较足够数量且不同种类的案例,试图归纳出适用于所有项目的思想与方法. 这么做并不牵强,因为不同项目间确实具有共同的特性,可以使用相同的思想与方法论来执行,就如同我们的本行-嵌入式系统与电子产品开发,如果不能在不同的项目间秉持共通的概念,工程人员免不了要多走很			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba7V5gp.html" rel="bookmark">项目经理应该把 30&percnt; 的时间用在编程上</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文的作者Eliot Horowitz是MongoDB的创始人和技术总监. 在一个科技公司里,软件技术经理用在编程上的时间应该不低于总工作时间的30%.无论是管理一个团队,还是一个分部,还是整个公司,当技术经理用在编程上的时间低于30%时,他执行职责的能力就会发生严重退化. 我的这个断言可能跟那些我看到的想成为团队首领的软件程序员们期望的情况完全相反.每次晋升,程序员们都期待花在编码上的时间会大幅度减少,当从 &quot;leader&quot;爬到&quot;经理&quot;职位时,就应该彻底脱离编码活			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKN3kz.html" rel="bookmark">大家觉得这样的项目经理是不是傻逼&period;&period;&period;&period;&period;&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我弄完个东西....就过来只关心按钮放那个位置网页的标题改一下一些不痛不痒的问题程序的逻辑一点也不关心(其实他也不懂)还尼玛说这个这个下午做完啊,我草合着我现在为了你那点P事要停下我手头重要的活.....后来好了我跟他说这些事你找设计人员去.... 解决方案 解决方案二: 解决方案三:你私下抱怨一下也就算了.也许你在他那个位置上,谁知道呢,又没有真正比试过,也许还不如他呢.解决方案四:幼稚的做法只能过个嘴瘾,其实伤害不了别人,只不过把阴损传给自己和身边的人,会让你变得气虚血虚影响你小身			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnR8w2p.html" rel="bookmark">请教：做产品的公司，项目经理到底该不该负责产品的策划</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在做产品的公司里面,公司想要一个业务平台,但是只有高层领导很粗糙的想法,就再没有明确的需求了.项目经理该不该负责自己定义各种产品的功能.数据.流程等需求,我感觉产品要做成什么样应该由产品策划人员或者产品经理来负责啊,项目经理应该只负责如何去实现.如果要做成什么样子都由项目经理来负责,那项目经理不也肩负产品经理职能了? 问题补充:高级java工程师 写道 解决方案 在小的公司一般项目经理,需求.代码.开会.架构.流程图.数据库结构图.类关系图.都要搞,一般公司有自己的架构,如果有,在平台			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJP1mp.html" rel="bookmark">一个项目经理的经验总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本人做项目经理工作多年,感到做这个工作最要紧的就是要明白什么是因地制宜.因势利导,只有最合适的,没有什么叫对的,什么叫错的,项目经理最忌讳的就是完美主义倾向,尤其是做技术人员出身的,喜欢寻找标准答案,耽误了工作进度,也迷茫了自己.以下是本人一些做项目的个人体会,写出来供大家指点,在讨论过程中共同提高水平. 项目开始阶段是一个最重要的阶段.项目经理在接手一个新项目的时候,首先要尽可能地多从各个方面了解项目的情况,如: 1. 这个项目是什么项目,具体大概做什么事情,是谁提出来的,目的是解决什么问题.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmGJap.html" rel="bookmark">项目经理是什么心理？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 到这家公司半年多了,自从我进来以后,项目经理就把全部事情都交给我一个人做,办公室里面还有几个人,每天除了耍还是耍,其中有两个人给我说:他们实在耍得太无聊了,准备辞职!有个同事也和我聊过说他也想不通为什么项目经理要把所有事情喊我一个人做.我现在的状况经常是:正在改这个系统的时候项目经理过来喊我马上改另外一个系统,而其他几个人完全没事做.我的工资也是这里最低档次的,在场的有项目经理嘛?能不能帮我分析一下我们项目经理到底是什么心理? 解决方案 我的想法基本同意楼上的朋友.你的项目经理这么做,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM620AM.html" rel="bookmark" class="title">指针-c语言中字符数组初始化问题</a>
					<div>
						问题描述 c语言中字符数组初始化问题 字符数组初始化1: char str[]=&quot;&quot;123&quot;&quot;;//不报错2: char str[4]; str=&quot;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJdB6M.html" rel="bookmark" class="title">CN域名只是一场华丽的幻觉</a>
					<div>
						在这场喧闹的手机扫黄打非运动中,中国移动湿了,很多手机网站湿了,很多IDC湿了,很多站长湿了.理所当然的,当CCAV揭露到这一切都是因为CNNIC不严格审批域名注册信息的时候,CNNIC&quot;被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLXP0p.html" rel="bookmark" class="title">使用Iptables的功能扩展全面封杀P2P流量</a>
					<div>
						Linux真是好东西啊!Linux系统不但稳定,平台相对安全,而且还是开放源代码且是免费的,其中的iptables更是功能强大,所以笔者公司一直在用他做公司的内部网关, 并通过iptables 的设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeE59z.html" rel="bookmark" class="title">做SEO关注排名 更应该关注SEO带来的效益</a>
					<div>
						网站的SEO工作做的好与不好,关注关键词排名位置的同时,更应该关注网站通过SEO优化后带来了多少收益.如果有了排名却没有多少收益的话,那么这样的SEO不如不做,因为根本没有体现做SEO的价值.真正的S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4l9Yz.html" rel="bookmark" class="title">全方位剖析seo实战大型站群网站之怎样进行关键字分布</a>
					<div>
						上次讲到优化页面关键字,这次主要讲关键字的分布; 经过核心关键字的确定及关键字的扩展,这样下来会达到几十或者几百个关键字.如何对这些关键字进行合理分布,对一个初学seo的人来讲,还是有点迷惑的. 金字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8nwlb.html" rel="bookmark" class="title">数据调查：关于谷歌的个性化搜索大部分人持否定态度</a>
					<div>
						在本月的早些时候,市场数据调查工具提供商Ask Your Target Market(简称SYTM),调查机构对400个美国成年人进行关于对谷歌个性化搜索的态度.今天其公布了调查结果.我们分析调查结果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPr28z.html" rel="bookmark" class="title">光纤通信优点</a>
					<div>
						光纤通信之所以受到人们的极大重视,这是因为和其它通信手段相比,具有无以伦比的优越性. 1.通信容量大 从理论上讲,一根仅有头发丝粗细的光纤可以同时传输1000 亿个话路.虽然目前远远未达到如此高的传输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEWAWb.html" rel="bookmark" class="title">10&period;6寸酷比魔方CDK02底座键盘怎么样&quest;</a>
					<div>
						  10.6寸酷比魔方CDK02底座键盘怎么样?         底座键盘这种产品,是针对各种尺寸的平板主机的外设之一,主要按尺寸分类,因为目前的平板产品都在底部设计有几个金属触点,用于搭配键盘使用, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBmnnz.html" rel="bookmark" class="title">电脑卸载驱动程序并重启后驱动又自动安装怎么解决</a>
					<div>
						  电脑卸载驱动程序并重启后驱动又自动安装怎么解决          1.右击计算机图标,选择打开&quot;属性&quot;,然后点击左上角的&quot;高级系统设置&quot;; 2.点击硬件选项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NY0nz.html" rel="bookmark" class="title">如何在 RHEL 上设置 Linux RAID 1</a>
					<div>
						设置 Linux RAID 1 配置 LINUX RAID 1 非常重要,因为它提供了冗余性. RAID 分区拥有高级功能,如冗余和更好的性能.所以让我们来说下如何实现 RAID,以及让我们来看看不同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGA08oM.html" rel="bookmark" class="title">函数式语言-Scheme语言的map函数求行列式的积</a>
					<div>
						问题描述 Scheme语言的map函数求行列式的积 利用scheme的map函数求解行列式的积 例如 '((1 2)(3 4)) '((5 7)(6 8)) 得到结果(1*5+2*7 1*6+2*8) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrQ0ZM.html" rel="bookmark" class="title">求大神看看，C语言二叉树非递归遍历问题 ，最后输出正确，然后在程序崩溃</a>
					<div>
						问题描述 求大神看看,C语言二叉树非递归遍历问题 ,最后输出正确,然后在程序崩溃 #include #include #include typedef struct TNode { char date ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmn0kz.html" rel="bookmark" class="title">苹果在美申请&OpenCurlyDoubleQuote;多点触控&rdquo;商标遭拒绝</a>
					<div>
						新浪科技讯 北京时间9月27日上午消息,美国专利与商标局(以下简称&quot;USPTO&quot;)上周做出裁决,拒绝将&quot;Multi-Touch&quot;(多点触控)商标授予苹果.在科技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q058p.html" rel="bookmark" class="title">c语言-请问C语言中a和225有什么关系</a>
					<div>
						问题描述 请问C语言中a和225有什么关系 gocr软件中的一部分代码 switch (main) {... case 'a': return LATIN_SMALL_LETTER_A_WITH_AC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7XX4p.html" rel="bookmark" class="title">CSS权威指南之css声明，伪类，文本处理--&lpar;简要笔记一&rpar;</a>
					<div>
						1.css层叠的含义 后面的会覆盖前面的样式   2.每个元素生成一个框,也称盒.   3.替换元素和非替换元素. img如果不指定src的外部路径,该元素就没有意义.他由文档本身之外的一个图像文件来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lyerb.html" rel="bookmark" class="title">androidstudio的编码格式的小问题</a>
					<div>
						问题描述 androidstudio的编码格式的小问题 请问一下这是什么错误,我程序运行的时候一部分地方也会出现乱码的状况File encoding disabled Encoding hard-co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAARKM.html" rel="bookmark" class="title">PostgreSQL 9&period;6 水平分库，还差一点点啦</a>
					<div>
						PostgreSQL 持续在基于fdw的sharding技术上深耕,9.6开始,在符合条件的前提下,支持JOIN和SORT下推到数据节点执行.下面是一个测试创建几个shard库 for subfix  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeAaob.html" rel="bookmark" class="title">spring 拦截方法中如何获取拦截器中变量的值</a>
					<div>
						问题描述 spring 拦截方法中如何获取拦截器中变量的值 想在拦截方法中获取拦截器中变量的值,如何用代码实现?求指教.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKAxDb.html" rel="bookmark" class="title">索尼爱立信手机遥控器LiveView将上市</a>
					<div>
						随着http://www.aliyun.com/zixun/aggregation/2412.html&quot;&gt;智能手机产品功能性的不断增强,越来越多的智能手机配件也来到消费者的身边.此前, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZJNqz.html" rel="bookmark" class="title">中小企业简化存储一二三</a>
					<div>
						如今,越来越多的企业和机构已经把存储作为其信息化投资的一个必须,无论是大企业,如电信公司,汽车制造公司或网站公司:还是政府机构,如国家信息中心,税务部门或海关,都拥有了大型的存储设备和技术.随着存储技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXBKmz.html" rel="bookmark" class="title">c语言中getch&comma;getche&comma;getchar的区别&lowbar;C 语言</a>
					<div>
						getchar 是stdio.h中的库函数,它的作用是从stdin流中读入一个字符,也就是说 ,如果stdin有数据的话不用输入就可以直接读取了.而getch()和getche()是conio.h中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeVyXb.html" rel="bookmark" class="title">SEOer为什么要学习HTML语言</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 新手SEOer为什么要学习HTML ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBwW8b.html" rel="bookmark" class="title">14款经典的MySQL客户端软件</a>
					<div>
						不用我说,大家都知道Mysql是一个怎么样的数据库.虽然它的命运比较坎坷, 但是丝毫没有影响到我们对Mysql的热情.不论是个人程序或者网站,还是企业数据库,Mysql的身影无处不在.无论做什么数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKdNqp.html" rel="bookmark" class="title">NM Restart Design Overview</a>
					<div>
						This document describes the design of the NodeManager restart work under YARN­1336 and its sub­JIRAs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBDR2M.html" rel="bookmark" class="title">数据库公交车运行管理系统</a>
					<div>
						问题描述 数据库公交车运行管理系统 数据库与信息管理课设公交车运行系统.谢谢大神们了.有没有现成的.好人一生平安. 解决方案 http://www.doc88.com/p-9921916178064. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnaK7M.html" rel="bookmark" class="title">澳航和GE联手利用大数据降低成本并减少碳排放</a>
					<div>
						今天,GE Aviation在位于德克萨斯州奥斯汀的数字解决方案总部,推出了该公司第四个数字协作中心,澳航成为了该中心的首家客户. GE已经和澳航建立了长期合作关系,并为澳航提供了大约三分之二的引擎及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEBEQM.html" rel="bookmark" class="title">金字塔形的国内团购网站现状</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 随着团购网站在国内热火朝天的蔓延, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW77WrM.html" rel="bookmark" class="title">ASP中应用事务处理技巧&lowbar;应用技巧</a>
					<div>
						所谓事务,是指一系列必须都成功的操作,只要有一步操作失败,其他的步骤也必须撤销.其实在数据库系统中,每一条SQL语句都是一个事务,当执行这条语句的时候,要么执行成功,要么执行错误并退出到最初的状态.但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNVEZp.html" rel="bookmark" class="title">sql数据库中如何根据身份证号判断性别</a>
					<div>
						问题描述 身份证号有15位和18位的..在sql中该如何判断?I_sex=casewhenlen(s_sfzhm)=15andSubstring(s_sfzhm,15,1)in(1,3,5,7,9)t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z0YJz.html" rel="bookmark" class="title">医疗行业大数据应用三点建议</a>
					<div>
						从目前情况看,实现医院信息基础平台的整合,在技术和产品方面没有任何障碍,最关键的是用户的观念能否转变过来.其实,医院用于购买医疗专业设备的费用高于对IT的投入.医院的领导一定要转变过去那种IT部门是成 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
